"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _Field = _interopRequireDefault(require("./Field"));

var _Operation = _interopRequireDefault(require("./Operation"));

var _Parameter = _interopRequireDefault(require("./Parameter"));

/**
 * @property {string} name            - The name of the resource
 * @property {string} url             - The base URL for this resource
 */
var Resource =
/**
 * @param {string}          name
 * @param {string}          url
 * @param {ResourceOptions} options
 */
function Resource(name, url) {
  var _this = this;

  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  (0, _classCallCheck2["default"])(this, Resource);
  this.name = name;
  this.url = url;
  Object.keys(options).forEach(function (key) {
    Object.defineProperty(_this, key, {
      readable: true,
      writable: true,
      enumerable: true,
      value: options[key]
    });
  });
};

exports["default"] = Resource;