"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = parseOpenApi3Documentation;

var _Api = _interopRequireDefault(require("../Api"));

var _handleJson = _interopRequireWildcard(require("./handleJson"));

function parseOpenApi3Documentation(entrypointUrl) {
  entrypointUrl = (0, _handleJson.removeTrailingSlash)(entrypointUrl);
  return fetch(entrypointUrl).then(function (res) {
    return res.json();
  }).then(function (response) {
    var title = response.info.title;
    var resources = (0, _handleJson["default"])(response, entrypointUrl);
    return Promise.resolve({
      api: new _Api["default"](entrypointUrl, {
        title: title,
        resources: resources
      }),
      response: response,
      status: response.status
    });
  }, function (_ref) {
    var response = _ref.response;
    return Promise.reject({
      api: new _Api["default"](entrypointUrl, {
        resources: []
      }),
      response: response,
      status: response.status
    });
  });
}