"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;
exports.removeTrailingSlash = void 0;

var _lodash = _interopRequireDefault(require("lodash.get"));

var _lodash2 = _interopRequireDefault(require("lodash.uniq"));

var _Field = _interopRequireDefault(require("../Field"));

var _Resource = _interopRequireDefault(require("../Resource"));

var removeTrailingSlash = function removeTrailingSlash(url) {
  if (/\/$/.test(url)) {
    url = url.slice(0, -1);
  }

  return url;
};

exports.removeTrailingSlash = removeTrailingSlash;

function _default(response, entrypointUrl) {
  var paths = (0, _lodash2["default"])(Object.keys(response.paths).map(function (item) {
    return item.replace("/{id}", "");
  }));
  var resources = paths.map(function (item) {
    var name = item.replace("/", "");
    var url = removeTrailingSlash(entrypointUrl) + item;
    var firstMethod = Object.keys(response.paths[item])[0];
    var title = response.paths[item][firstMethod]["tags"][0];
    var fieldNames = Object.keys(response.definitions[title].properties);
    var requiredFields = (0, _lodash["default"])(response, ["definitions", title, "required"], []);
    var fields = fieldNames.map(function (fieldName) {
      return new _Field["default"](fieldName, {
        id: null,
        range: null,
        reference: null,
        required: !!requiredFields.find(function (value) {
          return value === fieldName;
        }),
        description: (0, _lodash["default"])(response.definitions[title].properties[fieldName], "description", "")
      });
    });
    return new _Resource["default"](name, url, {
      id: null,
      title: title,
      fields: fields,
      readableFields: fields,
      writableFields: fields
    });
  });
  return resources;
}